<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SemanticSearchEvaluation: Main Page</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SemanticSearchEvaluation
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">SemanticSearchEvaluation Documentation</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p><a class="anchor" id="md_C__Users_sb-admin_source_repos_SemanticSearchEvaluation_readme"></a>This repository contains the code for the evaluation of different approaches for building a search engine for RDF-based metadata records presented in the master thesis <a href="http://dx.doi.org/10.18154/RWTH-2020-09883">"An Efficient Semantic Search Engine for Research Data in an RDF-based Knowledge Graph"</a> as well as the used code to generate example metadata records of engmeta2 profile.</p>
<h2><a class="anchor" id="autotoc_md0"></a>
Evaluation results:</h2>
<p>All calculated evaluation results used and presented in the <a href="http://dx.doi.org/10.18154/RWTH-2020-09883">master thesis</a> can be found in the folder <em>evaluation_results</em>.</p>
<h2><a class="anchor" id="autotoc_md1"></a>
Code documentation:</h2>
<p>The code documentation can be found under *./docs/index.html*.</p>
<h2><a class="anchor" id="autotoc_md2"></a>
Setup/Prerequisites:</h2>
<ul>
<li>Virtuoso<ul>
<li>Virtuoso.ini file<ul>
<li>NumberOfBuffers &gt;= 660000</li>
<li>MaxDirtyBuffers &gt;= 495000</li>
</ul>
</li>
<li>Default settings:<ul>
<li>Sever: localhost</li>
<li>Port: 1111</li>
<li>Database: db</li>
<li>Database user: dba</li>
<li>Database password: dba</li>
</ul>
</li>
<li>Define the following graphs as rulesets named "ruleset" for inference rules with &lsquo;rdfs_rule_set (&rsquo;&lt;rulesetname&gt;', '&lt;graphname&gt;') ;`<ul>
<li><a href="http://www.dfg.de/dfg_profil/gremien/fachkollegien/faecher/">http://www.dfg.de/dfg_profil/gremien/fachkollegien/faecher/</a></li>
<li><a href="http://www.w3.org/ns/org#">http://www.w3.org/ns/org#</a></li>
<li><a href="http://xmlns.com/foaf/0.1/">http://xmlns.com/foaf/0.1/</a></li>
</ul>
</li>
</ul>
</li>
<li>Data mentioned in <a href="http://dx.doi.org/10.18154/RWTH-2020-09886">"Sample Dataset for Search Engine Evaluation for Research Data in an RDF-based Knowledge Graph"</a><ul>
<li>All named_graphs, use <em>virtuoso.db/graphs.db</em></li>
</ul>
</li>
<li>Elasticsearch<ul>
<li>Default settings:<ul>
<li>Server: localhost</li>
<li>Port: 9200</li>
</ul>
</li>
</ul>
</li>
<li>Specified packages</li>
</ul>
<h2><a class="anchor" id="autotoc_md3"></a>
How to use:</h2>
<ol type="1">
<li>Copy all files from <em>Release</em>/*Debug* folder from <a href="http://dx.doi.org/10.18154/RWTH-2020-09884">SemanticSearchImplementation project</a> (after building it) to <em>SemanticSearchImplementation</em> folder</li>
<li>Install/restore necessary packages</li>
<li>Build solution (in Debug mode)</li>
<li>Change required data as described below (dependent on test)</li>
<li>Start Virtuoso</li>
<li>Start Elasticsearch</li>
<li>Run <em>SemanticEvaluation.exe</em> with the necessary arguments</li>
</ol>
<h3><a class="anchor" id="autotoc_md4"></a>
Response times and results on small data record</h3>
<ul>
<li>Use <em>virtuoso.db/small.db</em></li>
<li>Use <em>elasticsearch/small</em></li>
<li>Evaluation results could be found in <em>evaluation_results/time/small</em> and <em>evaluation_results/results/small</em> folders</li>
</ul>
<h3><a class="anchor" id="autotoc_md5"></a>
Response times and results on large data record</h3>
<ul>
<li>Maybe uncomment console output in the search approaches in the <em>SearchApproaches</em> folder because there are many results which are very time-consuming</li>
<li>Use <em>virtuoso.db/large.db</em></li>
<li>Use <em>elasticsearch/large</em></li>
<li>Evaluation results could be found in <em>evaluation_results/time/large</em> folder</li>
</ul>
<h3><a class="anchor" id="autotoc_md6"></a>
Reponse times on base/empty project for comparison</h3>
<p>Evaluation results could be found in <em>evaluation_results/time/empty</em> folder.</p>
<h3><a class="anchor" id="autotoc_md7"></a>
Further Elasticsearch time measurements</h3>
<ul>
<li>As <em>path</em> parameter you have to specify the path to the metadata_records folder of the <a href="http://dx.doi.org/10.18154/RWTH-2020-09886">Sample Dataset</a></li>
<li>Evaluation results could be found in <em>evaluation_results/times/ES</em> folder</li>
<li>Reindexing: Use <em>virtuoso.db/large.db</em> and <em>elasticsearch/large</em></li>
<li>Add: Use <em>virtuoso.db/es_9900.db</em> and <em>elasticsearch/es_9900</em></li>
<li>Update: Use <em>virtuoso.db/large.db</em> and <em>elasticsearch/large</em></li>
<li>Delete: Use <em>virtuoso.db/large.db</em> and <em>elasticsearch/large</em></li>
<li>Tests for add/update/delete are executed with additional rule for newest version specified in engmeta2 profile. If you want to run it without additional rules you have to replace named graph <a href="https://purl.org/coscine/ap/engmeta2/">https://purl.org/coscine/ap/engmeta2/</a> by the same file (engmeta.ttl in <a href="http://dx.doi.org/10.18154/RWTH-2020-09886">Sample Dataset</a>) without the additional rule.</li>
</ul>
<h3><a class="anchor" id="autotoc_md8"></a>
Generate metadata records</h3>
<p>After execution, the generated metadata records can be found in the folder <em>data/engmeta2</em>.</p>
<h3><a class="anchor" id="autotoc_md9"></a>
Commandline arguments</h3>
<table class="markdownTable">
<tr class="markdownTableHead">
<th class="markdownTableHeadNone">Option  </th><th class="markdownTableHeadNone">Description   </th></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">-a, &ndash;action  </td><td class="markdownTableBodyNone">Required. Possible action: small, large, empty, elasticsearch, create   </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">-t, &ndash;test  </td><td class="markdownTableBodyNone">Possible tests for elasticsearch action: add, update, delete or reindex   </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">-p, &ndash;path  </td><td class="markdownTableBodyNone">Specify path to metadata records for elasticsearch action   </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">-n, &ndash;number  </td><td class="markdownTableBodyNone">Specify the number of metadata records to be generated for create action   </td></tr>
</table>
<h2><a class="anchor" id="autotoc_md10"></a>
Further notes:</h2>
<p>In the context of the master thesis the output of the results was omitted for stopping the times. To reproduce this, the console output of the results (as well as the selection of the results) would have to be commented out in the respective approach and the project would have to be rebuilt. Defining and setting the rulesets is also commented out.</p>
<p>The test for measuring the validation and storage of a metadata graph in Virtuoso by CoScInE is not included in the publication due to the need for authentication. It can be reproduced by using the <em>StoreMetadataForFile</em> method in the <a href="https://git.rwth-aachen.de/coscine/api/treeapi/-/blob/master/src/Tree/Controllers/TreeController.cs">TreeAPI</a> project. </p>
</div></div><!-- PageDoc -->
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>
</body>
</html>
